using System.Linq;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationNRFI
{
    public partial class NRFI2018Validator
    {
        #region VR.ATO.NRFI.100018

        protected bool VRATONRFI100018(NRFI2018 report)
        {
            /*  VR.ATO.NRFI.100018
            Foreign tax return period must be exactly one year when the Foreign income assessment method is "Overseas"
    
            Legacy Rule Format:
            IF [NRFI8] <> NULL AND [NRFI9] <> NULL AND [NRFI9] <> ConvertToDate(Day([NRFI8]) - 1, MonthAsInt([NRFI8]), Year([NRFI8]) + 1)
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^NRFI8 <> NULL AND ^NRFI9 <> NULL AND ^NRFI9 <> ConvertToDate(Day(^NRFI8) - 1, MonthAsInt(^NRFI8), Year(^NRFI8) + 1)
    
            Data Elements:
    
            RP:^NRFI9 = tns:Period.End.Date
    
            RP:^NRFI8 = tns:Period.Start.Date
            */
            bool assertion = (report.NRFI8 != null && report.NRFI9 != null && report.NRFI9.GetValueOrDefault() != report.NRFI8.GetValueOrDefault().AddDays(-1).AddYears(1));

            return assertion;
        }

        #endregion // VR.ATO.NRFI.100018
    }
}
