// ------------------------------------------------------------------------------
//  <auto-generated>
//     This code was generated from a template.
// 
//     Manual changes to this file will be overwritten if the code is regenerated.
//
//     Generated on 2017-03-16T13:37:52, by ESR Version 1.57.0.0 using ESR Database 
//  </auto-generated>
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using Au.Gov.Sbr.Xbrl.Document;
using Au.Gov.Sbr.Xbrl.Metadata;
using System.Linq;
using System.Xml;
using System.Text.RegularExpressions;
using DataContracts;

namespace Ato.EN.IntegrationServices.CodeGenerationWRE
{
    public class WRE2017Consumer
    {

        #region Helper/Validation Methods
        private static bool? ToBoolean(string str)
        {
            bool returnValue;
            string value = (str ?? "").Trim();
            if (value == "0" || value == "1")
                return Convert.ToBoolean(Convert.ToInt32(value));
            
            if (Boolean.TryParse(value, out returnValue))
                return returnValue;
            return null;
        }

        private static string GetValueOrEmpty(bool? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(DateTime? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        /// <summary>
        /// Derives the SBR element location.
        /// </summary>
        /// <param name="sbrElement">The SBR element.</param>
        /// <param name="addOccurrenceIndex">if set to <c>true</c> [add occurrence the occurrence index to the path].</param>
        /// <returns></returns>
        private static string DeriveSbrElementLocation(SBRElement sbrElement, bool addOccurrenceIndex = false)
        {
            if (sbrElement == null) return "/xbrli:xbrl";
            int xpathOccurrence = sbrElement.OccurrenceIndex + 1;
            string location;

            if (addOccurrenceIndex)
            {
                location = "/" + sbrElement.NamespacePrefix + ":" + sbrElement.Name + "[" +
                           xpathOccurrence + "]";
            }
            else
            {
                location = "/" + sbrElement.NamespacePrefix + ":" + sbrElement.Name;
            }

            if (sbrElement.IsInTuple)
            {
                location = DeriveSbrElementLocation(sbrElement.ParentTuple, true) + location;
            }
            else
            {
                location = "/xbrli:xbrl" + location;
            }

            return location;
        }

        private static bool IsMatch(int? field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(Convert.ToString(field.Value), expression, options);
        }

        private static bool IsMatch(string field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(field, expression, options);
        }

        public DateTime AsDate(string dateAsString)
        {
            DateTime response = DateTime.MinValue;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date;
            }

            return response;
        }

         #endregion

        public WRE2017 Consume(SBRDocument sbrDocument)
        {
            List<ProcessMessageDocument> errors;
            return Consume(sbrDocument, false, out errors);
        }

        /// <summary>
        /// Allows for validation of rules that can not be generated and must run at a lower level.
        /// A sub-class will need to be created with an override for this method - which does nothing in its base implementation.
        /// </summary>
        /// <param name="sbrDocument">The SBR document.</param>
        /// <param name="populatedReportElementsMap">The populated report elements map can be used to find data elements and tuples.</param>
        /// <param name="contextArray">The context array can be used to find context values.</param>
        /// <param name="errors">The errors collection is to be populated with validation results.</param>
        protected virtual void ValidateUnsupportedRules(SBRDocument sbrDocument, IDictionary<string, SBRElement> populatedReportElementsMap, SBRContext[] contextArray, List<ProcessMessageDocument> errors)
        {

        }

        public WRE2017 Consume(SBRDocument sbrDocument, bool validationMode, out List<ProcessMessageDocument> errors)
        {
            WRE2017 report;
            report = new WRE2017();
            errors = new List<ProcessMessageDocument>();

            SBRContext[] contextArray;
            IDictionary<string, SBRElement> populatedReportElementsMap;

            contextArray = sbrDocument.ContextsMap.Values.ToArray();
            populatedReportElementsMap = sbrDocument.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();

            if (validationMode) ValidateUnsupportedRules(sbrDocument, populatedReportElementsMap, contextArray, errors);

            /// <summary>
            /// Current element being extracted
            /// </summary>
            SBRElement currentValue = null;
            /// <summary>
            /// Current elements being extracted
            /// </summary>
            IList<SBRElement> currentValues = null;
            /// <summary>
            /// Current occurrances being extracted
            /// </summary>
            IList<SBRElement> currentOccurrences = null;
            /// <summary>
            /// Working Variable for date time variables
            /// </summary>
            DateTime currentDateTimeValue;
            /// <summary>
            /// Working Variable for boolean variables
            /// </summary>
            bool currentBooleanValue;
            /// <summary>
            /// Working Variable for decimal variables
            /// </summary>
            decimal currentDecimalValue;
            /// <summary>
            /// Working Variable for integer variables
            /// </summary>
            int currentIntValue;
            /// <summary>
            /// Working Variable for long variables
            /// </summary>
            long currentLongValue;
            XmlDocumentFragment currentSegment;
            XmlNamespaceManager currentNamespaceManager;
            XmlNode currentNode;
    
            #region sbrRPContext
            IEnumerable<SBRContext> sbrRPContexts = null;
            SBRContext sbrRPContext = null;
    
            sbrRPContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 1 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty")) ));
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPContexts != null && sbrRPContexts.Count() > 0)
            {
                sbrRPContext = sbrRPContexts.First();
        
                report.RPId = sbrRPContext.Id;
                report.RPIdentifier = sbrRPContext.EntityIdentifier;
                report.RPIdentifierScheme = sbrRPContext.EntityScheme;
        
                report.RPCount = sbrRPContexts.Count();
                report.RPExists = true;
                report.RPOccurrenceIndex = Array.IndexOf(contextArray, sbrRPContext) + 1;
                report.RPLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPContexts.Last()) + 1;
        

                if (report.RPIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPIdentifierTFN = report.RPIdentifier;
    
                report.RPStartDate = ((SBRDurationPeriod)sbrRPContext.Period).DurationStartAsDateObject;
                report.RPEndDate = ((SBRDurationPeriod)sbrRPContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPContexts.Count(); i++)
                {
                    sbrRPContext = sbrRPContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
                    report.WRE56 = report.RPStartDate;
                    report.WRE57 = report.RPEndDate;
                    report.WRE58 = report.RPIdentifier;
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.CarReason.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.WRE12 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.TravelReason.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.WRE24 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.ClothingReason.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.WRE31 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.EducationReason.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.WRE38 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.EducationReduction.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.WRE46 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.EducationNet.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.WRE47 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.WorkRelatedReasonOther.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.WRE49 = currentValues[0].Value;
                    }
                } 
            } 
            #endregion End of Context sbrRPContext
    
            #region sbrRPCarSeqNumContext
            IEnumerable<SBRContext> sbrRPCarSeqNumContexts = null;
            SBRContext sbrRPCarSeqNumContext = null;
    
            sbrRPCarSeqNumContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.TYPED && dd.Dimension.EndsWith("}CarSequenceDimension")) )));
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPCarSeqNumElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPCarSeqNumContexts != null && sbrRPCarSeqNumContexts.Count() > 0)
            {
        
                report.RPCarSeqNumContextCollection = new List<WRE2017.RPCarSeqNumContext>();
                for (int i = 0; i < sbrRPCarSeqNumContexts.Count(); i++)
                {
                    sbrRPCarSeqNumContext = sbrRPCarSeqNumContexts.ElementAt(i);
                    WRE2017.RPCarSeqNumContext rpCarSeqNumContext = new WRE2017.RPCarSeqNumContext();
                    report.RPCarSeqNumContextCollection.Add(rpCarSeqNumContext);
            
                    rpCarSeqNumContext.Id = sbrRPCarSeqNumContext.Id;
                    rpCarSeqNumContext.Identifier = sbrRPCarSeqNumContext.EntityIdentifier;
                    rpCarSeqNumContext.IdentifierScheme = sbrRPCarSeqNumContext.EntityScheme;
            
                    rpCarSeqNumContext.Count = sbrRPCarSeqNumContexts.Count();
                    rpCarSeqNumContext.Exists = true;
                    rpCarSeqNumContext.OccurrenceIndex = Array.IndexOf(contextArray, sbrRPCarSeqNumContext) + 1;
                    rpCarSeqNumContext.LastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPCarSeqNumContexts.Last()) + 1;
            
    
                    if (rpCarSeqNumContext.IdentifierScheme == "http://www.ato.gov.au/tfn") rpCarSeqNumContext.IdentifierTFN = rpCarSeqNumContext.Identifier;
        
                    rpCarSeqNumContext.StartDate = ((SBRDurationPeriod)sbrRPCarSeqNumContext.Period).DurationStartAsDateObject;
                    rpCarSeqNumContext.EndDate = ((SBRDurationPeriod)sbrRPCarSeqNumContext.Period).DurationEndAsDateObject;
            
                    currentSegment = sbrRPCarSeqNumContext.Segment.Segment;
            
                    currentNamespaceManager = new XmlNamespaceManager(currentSegment.OwnerDocument.NameTable);
                    currentNamespaceManager.AddNamespace("xbrldi", "http://xbrl.org/2006/xbrldi");
            
                    currentNode = currentSegment.SelectSingleNode("xbrldi:typedMember[contains(@dimension, 'CarSequenceDimension')]", currentNamespaceManager);
            
                    if (currentNode != null)
                    {
                        rpCarSeqNumContext.CarSequenceDimensionValue = currentNode.InnerText.Trim();
                    }
            
                    sbrPopulatedRPCarSeqNumElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPCarSeqNumContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPCarSeqNumElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPCarSeqNumElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPCarSeqNumElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
                    rpCarSeqNumContext.WRE60 = rpCarSeqNumContext.CarSequenceDimensionValue;
            
                    if (sbrPopulatedRPCarSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}Assets.CarMakeModel.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpCarSeqNumContext.WRE13 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPCarSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.CarCalculationMethod.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpCarSeqNumContext.WRE15 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPCarSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.CarLogBookMethodBusinessUseRecorded.Percent", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpCarSeqNumContext.WRE16 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPCarSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.CarLogBookMethodBusinessUseClaimed.Percent", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpCarSeqNumContext.WRE17 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPCarSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.CarBusinessKilometres.Number", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpCarSeqNumContext.WRE18 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPCarSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.CarStandardEvidenceCalculation.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpCarSeqNumContext.WRE20 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPCarSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.CarStandardEvidenceCalculationOther.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpCarSeqNumContext.WRE21 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPCarSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.Car.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpCarSeqNumContext.WRE22 = decimal.Parse(currentValues[0].Value);
                    }
        } 
            } 
            #endregion End of Context sbrRPCarSeqNumContext
    
            #region sbrRPTrvlSeqNumContext
            IEnumerable<SBRContext> sbrRPTrvlSeqNumContexts = null;
            SBRContext sbrRPTrvlSeqNumContext = null;
    
            sbrRPTrvlSeqNumContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.TYPED && dd.Dimension.EndsWith("}TravelSequenceDimension")) )));
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPTrvlSeqNumElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPTrvlSeqNumContexts != null && sbrRPTrvlSeqNumContexts.Count() > 0)
            {
        
                report.RPTrvlSeqNumContextCollection = new List<WRE2017.RPTrvlSeqNumContext>();
                for (int i = 0; i < sbrRPTrvlSeqNumContexts.Count(); i++)
                {
                    sbrRPTrvlSeqNumContext = sbrRPTrvlSeqNumContexts.ElementAt(i);
                    WRE2017.RPTrvlSeqNumContext rpTrvlSeqNumContext = new WRE2017.RPTrvlSeqNumContext();
                    report.RPTrvlSeqNumContextCollection.Add(rpTrvlSeqNumContext);
            
                    rpTrvlSeqNumContext.Id = sbrRPTrvlSeqNumContext.Id;
                    rpTrvlSeqNumContext.Identifier = sbrRPTrvlSeqNumContext.EntityIdentifier;
                    rpTrvlSeqNumContext.IdentifierScheme = sbrRPTrvlSeqNumContext.EntityScheme;
            
                    rpTrvlSeqNumContext.Count = sbrRPTrvlSeqNumContexts.Count();
                    rpTrvlSeqNumContext.Exists = true;
                    rpTrvlSeqNumContext.OccurrenceIndex = Array.IndexOf(contextArray, sbrRPTrvlSeqNumContext) + 1;
                    rpTrvlSeqNumContext.LastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPTrvlSeqNumContexts.Last()) + 1;
            
    
                    if (rpTrvlSeqNumContext.IdentifierScheme == "http://www.ato.gov.au/tfn") rpTrvlSeqNumContext.IdentifierTFN = rpTrvlSeqNumContext.Identifier;
        
                    rpTrvlSeqNumContext.StartDate = ((SBRDurationPeriod)sbrRPTrvlSeqNumContext.Period).DurationStartAsDateObject;
                    rpTrvlSeqNumContext.EndDate = ((SBRDurationPeriod)sbrRPTrvlSeqNumContext.Period).DurationEndAsDateObject;
            
                    currentSegment = sbrRPTrvlSeqNumContext.Segment.Segment;
            
                    currentNamespaceManager = new XmlNamespaceManager(currentSegment.OwnerDocument.NameTable);
                    currentNamespaceManager.AddNamespace("xbrldi", "http://xbrl.org/2006/xbrldi");
            
                    currentNode = currentSegment.SelectSingleNode("xbrldi:typedMember[contains(@dimension, 'TravelSequenceDimension')]", currentNamespaceManager);
            
                    if (currentNode != null)
                    {
                        rpTrvlSeqNumContext.TravelSequenceDimensionValue = currentNode.InnerText.Trim();
                    }
            
                    sbrPopulatedRPTrvlSeqNumElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPTrvlSeqNumContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPTrvlSeqNumElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPTrvlSeqNumElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPTrvlSeqNumElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
                    rpTrvlSeqNumContext.WRE61 = rpTrvlSeqNumContext.TravelSequenceDimensionValue;
            
                    if (sbrPopulatedRPTrvlSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.TravelCategory.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpTrvlSeqNumContext.WRE25 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPTrvlSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.TravelCategoryOther.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpTrvlSeqNumContext.WRE26 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPTrvlSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.TravelStandardEvidenceCalculation.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpTrvlSeqNumContext.WRE27 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPTrvlSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.TravelStandardEvidenceCalculationOther.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpTrvlSeqNumContext.WRE28 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPTrvlSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.Travel.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpTrvlSeqNumContext.WRE29 = decimal.Parse(currentValues[0].Value);
                    }
        } 
            } 
            #endregion End of Context sbrRPTrvlSeqNumContext
    
            #region sbrRPClthngSeqNumContext
            IEnumerable<SBRContext> sbrRPClthngSeqNumContexts = null;
            SBRContext sbrRPClthngSeqNumContext = null;
    
            sbrRPClthngSeqNumContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.TYPED && dd.Dimension.EndsWith("}ClothingSequenceDimension")) )));
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPClthngSeqNumElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPClthngSeqNumContexts != null && sbrRPClthngSeqNumContexts.Count() > 0)
            {
        
                report.RPClthngSeqNumContextCollection = new List<WRE2017.RPClthngSeqNumContext>();
                for (int i = 0; i < sbrRPClthngSeqNumContexts.Count(); i++)
                {
                    sbrRPClthngSeqNumContext = sbrRPClthngSeqNumContexts.ElementAt(i);
                    WRE2017.RPClthngSeqNumContext rpClthngSeqNumContext = new WRE2017.RPClthngSeqNumContext();
                    report.RPClthngSeqNumContextCollection.Add(rpClthngSeqNumContext);
            
                    rpClthngSeqNumContext.Id = sbrRPClthngSeqNumContext.Id;
                    rpClthngSeqNumContext.Identifier = sbrRPClthngSeqNumContext.EntityIdentifier;
                    rpClthngSeqNumContext.IdentifierScheme = sbrRPClthngSeqNumContext.EntityScheme;
            
                    rpClthngSeqNumContext.Count = sbrRPClthngSeqNumContexts.Count();
                    rpClthngSeqNumContext.Exists = true;
                    rpClthngSeqNumContext.OccurrenceIndex = Array.IndexOf(contextArray, sbrRPClthngSeqNumContext) + 1;
                    rpClthngSeqNumContext.LastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPClthngSeqNumContexts.Last()) + 1;
            
    
                    if (rpClthngSeqNumContext.IdentifierScheme == "http://www.ato.gov.au/tfn") rpClthngSeqNumContext.IdentifierTFN = rpClthngSeqNumContext.Identifier;
        
                    rpClthngSeqNumContext.StartDate = ((SBRDurationPeriod)sbrRPClthngSeqNumContext.Period).DurationStartAsDateObject;
                    rpClthngSeqNumContext.EndDate = ((SBRDurationPeriod)sbrRPClthngSeqNumContext.Period).DurationEndAsDateObject;
            
                    currentSegment = sbrRPClthngSeqNumContext.Segment.Segment;
            
                    currentNamespaceManager = new XmlNamespaceManager(currentSegment.OwnerDocument.NameTable);
                    currentNamespaceManager.AddNamespace("xbrldi", "http://xbrl.org/2006/xbrldi");
            
                    currentNode = currentSegment.SelectSingleNode("xbrldi:typedMember[contains(@dimension, 'ClothingSequenceDimension')]", currentNamespaceManager);
            
                    if (currentNode != null)
                    {
                        rpClthngSeqNumContext.ClothingSequenceDimensionValue = currentNode.InnerText.Trim();
                    }
            
                    sbrPopulatedRPClthngSeqNumElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPClthngSeqNumContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPClthngSeqNumElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPClthngSeqNumElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPClthngSeqNumElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
                    rpClthngSeqNumContext.WRE62 = rpClthngSeqNumContext.ClothingSequenceDimensionValue;
            
                    if (sbrPopulatedRPClthngSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.ClothingCategory.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpClthngSeqNumContext.WRE32 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPClthngSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.ClothingCategoryOther.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpClthngSeqNumContext.WRE33 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPClthngSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.ClothingStandardEvidenceCalculation.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpClthngSeqNumContext.WRE34 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPClthngSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.ClothingStandardEvidenceCalculationOther.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpClthngSeqNumContext.WRE35 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPClthngSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.Clothing.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpClthngSeqNumContext.WRE36 = decimal.Parse(currentValues[0].Value);
                    }
        } 
            } 
            #endregion End of Context sbrRPClthngSeqNumContext
    
            #region sbrRPEduSeqNumContext
            IEnumerable<SBRContext> sbrRPEduSeqNumContexts = null;
            SBRContext sbrRPEduSeqNumContext = null;
    
            sbrRPEduSeqNumContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.TYPED && dd.Dimension.EndsWith("}EducationSequenceDimension")) )));
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPEduSeqNumElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPEduSeqNumContexts != null && sbrRPEduSeqNumContexts.Count() > 0)
            {
        
                report.RPEduSeqNumContextCollection = new List<WRE2017.RPEduSeqNumContext>();
                for (int i = 0; i < sbrRPEduSeqNumContexts.Count(); i++)
                {
                    sbrRPEduSeqNumContext = sbrRPEduSeqNumContexts.ElementAt(i);
                    WRE2017.RPEduSeqNumContext rpEduSeqNumContext = new WRE2017.RPEduSeqNumContext();
                    report.RPEduSeqNumContextCollection.Add(rpEduSeqNumContext);
            
                    rpEduSeqNumContext.Id = sbrRPEduSeqNumContext.Id;
                    rpEduSeqNumContext.Identifier = sbrRPEduSeqNumContext.EntityIdentifier;
                    rpEduSeqNumContext.IdentifierScheme = sbrRPEduSeqNumContext.EntityScheme;
            
                    rpEduSeqNumContext.Count = sbrRPEduSeqNumContexts.Count();
                    rpEduSeqNumContext.Exists = true;
                    rpEduSeqNumContext.OccurrenceIndex = Array.IndexOf(contextArray, sbrRPEduSeqNumContext) + 1;
                    rpEduSeqNumContext.LastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPEduSeqNumContexts.Last()) + 1;
            
    
                    if (rpEduSeqNumContext.IdentifierScheme == "http://www.ato.gov.au/tfn") rpEduSeqNumContext.IdentifierTFN = rpEduSeqNumContext.Identifier;
        
                    rpEduSeqNumContext.StartDate = ((SBRDurationPeriod)sbrRPEduSeqNumContext.Period).DurationStartAsDateObject;
                    rpEduSeqNumContext.EndDate = ((SBRDurationPeriod)sbrRPEduSeqNumContext.Period).DurationEndAsDateObject;
            
                    currentSegment = sbrRPEduSeqNumContext.Segment.Segment;
            
                    currentNamespaceManager = new XmlNamespaceManager(currentSegment.OwnerDocument.NameTable);
                    currentNamespaceManager.AddNamespace("xbrldi", "http://xbrl.org/2006/xbrldi");
            
                    currentNode = currentSegment.SelectSingleNode("xbrldi:typedMember[contains(@dimension, 'EducationSequenceDimension')]", currentNamespaceManager);
            
                    if (currentNode != null)
                    {
                        rpEduSeqNumContext.EducationSequenceDimensionValue = currentNode.InnerText.Trim();
                    }
            
                    sbrPopulatedRPEduSeqNumElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPEduSeqNumContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPEduSeqNumElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPEduSeqNumElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPEduSeqNumElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
                    rpEduSeqNumContext.WRE63 = rpEduSeqNumContext.EducationSequenceDimensionValue;
            
                    if (sbrPopulatedRPEduSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}Identifiers.CourseName.Text", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpEduSeqNumContext.WRE39 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPEduSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}Identifiers.InstitutionName.Text", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpEduSeqNumContext.WRE40 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPEduSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.EducationCategory.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpEduSeqNumContext.WRE41 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPEduSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.EducationCategoryOther.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpEduSeqNumContext.WRE42 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPEduSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.EducationStandardEvidenceCalculation.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpEduSeqNumContext.WRE43 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPEduSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.EducationStandardEvidenceCalculationOther.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpEduSeqNumContext.WRE44 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPEduSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.Education.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpEduSeqNumContext.WRE45 = decimal.Parse(currentValues[0].Value);
                    }
        } 
            } 
            #endregion End of Context sbrRPEduSeqNumContext
    
            #region sbrRPOTHWRSeqNumContext
            IEnumerable<SBRContext> sbrRPOTHWRSeqNumContexts = null;
            SBRContext sbrRPOTHWRSeqNumContext = null;
    
            sbrRPOTHWRSeqNumContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.TYPED && dd.Dimension.EndsWith("}OtherWorkRelatedSequenceDimension")) )));
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPOTHWRSeqNumElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPOTHWRSeqNumContexts != null && sbrRPOTHWRSeqNumContexts.Count() > 0)
            {
        
                report.RPOTHWRSeqNumContextCollection = new List<WRE2017.RPOTHWRSeqNumContext>();
                for (int i = 0; i < sbrRPOTHWRSeqNumContexts.Count(); i++)
                {
                    sbrRPOTHWRSeqNumContext = sbrRPOTHWRSeqNumContexts.ElementAt(i);
                    WRE2017.RPOTHWRSeqNumContext rpothwrSeqNumContext = new WRE2017.RPOTHWRSeqNumContext();
                    report.RPOTHWRSeqNumContextCollection.Add(rpothwrSeqNumContext);
            
                    rpothwrSeqNumContext.Id = sbrRPOTHWRSeqNumContext.Id;
                    rpothwrSeqNumContext.Identifier = sbrRPOTHWRSeqNumContext.EntityIdentifier;
                    rpothwrSeqNumContext.IdentifierScheme = sbrRPOTHWRSeqNumContext.EntityScheme;
            
                    rpothwrSeqNumContext.Count = sbrRPOTHWRSeqNumContexts.Count();
                    rpothwrSeqNumContext.Exists = true;
                    rpothwrSeqNumContext.OccurrenceIndex = Array.IndexOf(contextArray, sbrRPOTHWRSeqNumContext) + 1;
                    rpothwrSeqNumContext.LastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPOTHWRSeqNumContexts.Last()) + 1;
            
    
                    if (rpothwrSeqNumContext.IdentifierScheme == "http://www.ato.gov.au/tfn") rpothwrSeqNumContext.IdentifierTFN = rpothwrSeqNumContext.Identifier;
        
                    rpothwrSeqNumContext.StartDate = ((SBRDurationPeriod)sbrRPOTHWRSeqNumContext.Period).DurationStartAsDateObject;
                    rpothwrSeqNumContext.EndDate = ((SBRDurationPeriod)sbrRPOTHWRSeqNumContext.Period).DurationEndAsDateObject;
            
                    currentSegment = sbrRPOTHWRSeqNumContext.Segment.Segment;
            
                    currentNamespaceManager = new XmlNamespaceManager(currentSegment.OwnerDocument.NameTable);
                    currentNamespaceManager.AddNamespace("xbrldi", "http://xbrl.org/2006/xbrldi");
            
                    currentNode = currentSegment.SelectSingleNode("xbrldi:typedMember[contains(@dimension, 'OtherWorkRelatedSequenceDimension')]", currentNamespaceManager);
            
                    if (currentNode != null)
                    {
                        rpothwrSeqNumContext.OtherWorkRelatedSequenceDimensionValue = currentNode.InnerText.Trim();
                    }
            
                    sbrPopulatedRPOTHWRSeqNumElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPOTHWRSeqNumContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPOTHWRSeqNumElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPOTHWRSeqNumElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPOTHWRSeqNumElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
                    rpothwrSeqNumContext.WRE64 = rpothwrSeqNumContext.OtherWorkRelatedSequenceDimensionValue;
            
                    if (sbrPopulatedRPOTHWRSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.WorkRelatedCategoryOther.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpothwrSeqNumContext.WRE50 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPOTHWRSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.WorkRelatedCategoryOther.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpothwrSeqNumContext.WRE51 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPOTHWRSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.WorkRelatedBusinessUseClaimedOther.Percent", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpothwrSeqNumContext.WRE52 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPOTHWRSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.WorkRelatedStandardEvidenceCalculationOther.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpothwrSeqNumContext.WRE53 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPOTHWRSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.WorkRelatedStandardEvidenceCalculationOther.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpothwrSeqNumContext.WRE54 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPOTHWRSeqNumElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/wre}IncomeTax.Deduction.WorkRelatedOther.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) rpothwrSeqNumContext.WRE55 = decimal.Parse(currentValues[0].Value);
                    }
        } 
            } 
            #endregion End of Context sbrRPOTHWRSeqNumContext
            return report;

        } // Of Consume Method
    } // Of Class
} // Of Namespace

